﻿using System;
using System.Management;
    
namespace ports
{
    public class MyWMIQuery
    {
        public static void Main()
        {
            Console.WriteLine();
            try
            {
                ManagementObjectSearcher searcher =
                    new ManagementObjectSearcher("root\\CIMV2",
                    "SELECT * FROM Win32_PnPEntity");

                int longestname = 4;
                int longestmanufacturer = 12;

                foreach (ManagementObject queryObj in searcher.Get())
                {

                    if ((string)queryObj["PNPClass"] == "Ports")
                    {

                        if (longestname < queryObj["Name"].ToString().Length)
                        {
                            longestname = queryObj["Name"].ToString().Length;
                        }

                        if (longestmanufacturer < queryObj["Manufacturer"].ToString().Length) 
                            {
                            longestmanufacturer = queryObj["Manufacturer"].ToString().Length;
                        }
                    }
                }

                string formatstring = "{0,-" + longestname + "} {1,-" + longestmanufacturer + "} {2}";

                Console.WriteLine(formatstring, "Name", "Manufacturer", "Status");
                Console.WriteLine(formatstring, "----", "------------", "------");
                foreach (ManagementObject queryObj in searcher.Get())
                {

                    if ((string)queryObj["PNPClass"] == "Ports")
                    {
                        Console.WriteLine(formatstring, queryObj["Name"], queryObj["Manufacturer"], queryObj["Status"]);
                    }
                }
            }
            catch (ManagementException e)
            {
                Console.WriteLine("An error occurred while querying for WMI data: " + e.Message);
            }


            Console.WriteLine("");

            if (Console.Title.Substring(0, 4) == "file" || Console.Title.Substring(1,1) == ":") // hack so we only do the key to close thing if somebody doubleclicked
            {

                Console.WriteLine("\nports.exe by Eli Fulkerson, 18 Aug 2015, http://www.elifulkerson.com");

                Console.WriteLine("\nPress a key to close");
                        
                Console.ReadKey();
            }
        }
    }
}

